## net.sf.saxon.pattern
Class IDPattern

    java.lang.Object
      net.sf.saxon.pattern.Pattern
          net.sf.saxon.pattern.IDPattern

All Implemented Interfaces:
  Serializable, SourceLocator, Container, PatternFinder

    public final class IDPattern

extends Pattern

An IDPattern is a pattern of the form id("literal") or id($variable)

See Also:
  Serialized Form

Constructor Summary
`IDPattern(Expression id)` Create an id pattern.

Method Summary
`Pattern` `analyze(StaticContext env, ItemType contextItemType)` Type-check the pattern.
`int` `getDependencies()` Get the dependencies of the pattern.
`int` `getNodeKind()` Determine the type of nodes to which this pattern applies.
`NodeTest` `getNodeTest()` Get a NodeTest that all the nodes matching this pattern must satisfy
`Iterator` `iterateSubExpressions()` Iterate over the subexpressions within this pattern
`boolean` `matches(NodeInfo e, XPathContext context)` Determine whether this Pattern matches the given Node
`void` `promote(PromotionOffer offer)` Offer promotion for subexpressions within this pattern.

Methods inherited from class net.sf.saxon.pattern.Pattern
`getColumnNumber, getDefaultPriority, getExecutable, getFingerprint, getHostLanguage, getLineNumber, getLocationProvider, getPublicId, getSystemId, make, makeSearchExpression, replaceSubExpression, selectNodes, setExecutable, setLineNumber, setOriginalText, setSystemId, simplify, toString`

Methods inherited from class java.lang.Object
`equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Constructor Detail

### IDPattern

    public IDPattern(Expression id)

  Create an id pattern.

  Parameters:
    `id` - Either a StringValue or a VariableReference

Method Detail

### analyze

    public Pattern analyze(StaticContext env,
                           ItemType contextItemType)
                    throws XPathException

  Type-check the pattern. Default implementation does nothing. This is only needed for patterns that contain variable references or function calls.

  Overrides:
    `analyze` in class `Pattern`
  Returns:
    the optimised Pattern
  Throws:
    `XPathException`

### getDependencies

    public int getDependencies()

  Get the dependencies of the pattern. The only possible dependency for a pattern is on local variables. This is analyzed in those patterns where local variables may appear.

  Overrides:
    `getDependencies` in class `Pattern`

### iterateSubExpressions

    public Iterator iterateSubExpressions()

  Iterate over the subexpressions within this pattern

  Overrides:
    `iterateSubExpressions` in class `Pattern`

### promote

    public void promote(PromotionOffer offer)
                 throws XPathException

  Offer promotion for subexpressions within this pattern. The offer will be accepted if the subexpression is not dependent on the factors (e.g. the context item) identified in the PromotionOffer. By default the offer is not accepted - this is appropriate in the case of simple expressions such as constant values and variable references where promotion would give no performance advantage. This method is always called at compile time.

  Unlike the corresponding method on `Expression`, this method does not return anything: it can make internal changes to the pattern, but cannot return a different pattern. Only certain kinds of promotion are applicable within a pattern: specifically, promotions affecting local variable references within the pattern.

  Overrides:
    `promote` in class `Pattern`
  Parameters:
    `offer` - details of the offer, for example the offer to move expressions that don't depend on the context to an outer level in the containing expression
  Throws:
    `XPathException` - if any error is detected

### matches

    public boolean matches(NodeInfo e,
                           XPathContext context)
                    throws XPathException

  Determine whether this Pattern matches the given Node

  Specified by:
    `matches` in class `Pattern`
  Parameters:
    `e` - The NodeInfo representing the Element or other node to be tested against the Pattern
    `context` - The dynamic context. Only relevant if the pattern uses variables, or contains calls on functions such as document() or key().
  Returns:
    true if the node matches the Pattern, false otherwise
  Throws:
    `XPathException`

### getNodeKind

    public int getNodeKind()

  Determine the type of nodes to which this pattern applies.

  Overrides:
    `getNodeKind` in class `Pattern`
  Returns:
    Type.ELEMENT

### getNodeTest

    public NodeTest getNodeTest()

  Get a NodeTest that all the nodes matching this pattern must satisfy

  Specified by:
    `getNodeTest` in class `Pattern`

Copyright (C) Michael H. Kay. All rights reserved.